/* @alwatr/unicode-digits v5.5.3 */
"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/main.ts
var main_exports = {};
__export(main_exports, {
  UnicodeDigits: () => UnicodeDigits
});
module.exports = __toCommonJS(main_exports);
var import_package_tracer = require("@alwatr/package-tracer");
__dev_mode__: import_package_tracer.packageTracer.add("@alwatr/unicode-digits", "5.5.3");
var supportedLanguageList = {
  en: 48,
  ar: 1632,
  fa: 1776,
  nko: 1984,
  hi: 2406,
  // devanagari
  bn: 2534,
  // bengali
  pa: 2662,
  // gurmukhi, punjabi
  gu: 2790,
  // gujarati
  or: 2918,
  // oriya
  ta: 3046,
  // tamil
  te: 3174,
  // telugu
  kn: 3302,
  // kannada
  mal: 3430,
  // malayalam
  sinhala_lith: 3558,
  thai: 3664,
  lao: 3792,
  tibetan: 3872,
  myanmar: 4160,
  myanmar_shan: 4240,
  khmer: 6112,
  mongolian: 6160,
  limbu: 6470,
  new_tai_lue: 6608,
  tai_tham_hora: 6784,
  tai_tham_tham: 6800,
  balinese: 6992,
  sundanese: 7088,
  lepcha: 7232,
  ol_chiki: 7248,
  vai: 42528,
  saurashtra: 43216,
  kayah_li: 43264,
  javanese: 43472,
  myanmar_tai_laing: 43504,
  cham: 43600,
  meetei_mayek: 44016,
  fullwidth: 65296,
  osmanya: 66720,
  brahmi: 69734,
  sora_sompeng: 69872,
  chakma: 69942,
  sharada: 70096,
  khudawadi: 70384,
  newa: 70736,
  tirhuta: 70864,
  modi: 71248,
  takri: 71360,
  ahom: 71472,
  warang_citi: 71904,
  bhaiksuki: 72784,
  mro: 92768,
  pahawh_hmong: 93008,
  mathematical_bold: 120782,
  "mathematical_double-struck": 120792,
  "mathematical_sans-serif": 120802,
  "mathematical_sans-serif_bold": 120812,
  mathematical_monospace: 120822,
  fula: 125264
  // adlam script in fula lang
};
var commonLangList = ["en", "fa", "ar"];
var UnicodeDigits = class {
  _replacer(_, ...args) {
    return String.fromCharCode(this._toLangZeroCode + args.findIndex((v) => v != null));
  }
  /**
   * Translate number.
   *
   * Example:
   *
   * ```ts
   * const unicodeDigits = new UnicodeDigits('en');
   *
   * const list = [
   *   '0123456789',
   *   '٠١٢٣٤٥٦٧٨٩',
   *   '߀߁߂߃߄߅߆߇߈߉',
   *   '०१२३४५६७८९',
   *   '০১২৩৪৫৬৭৮৯',
   *   '੦੧੨੩੪੫੬੭੮੯',
   *   '૦૧૨૩૪૫૬૭૮૯',
   *   '୦୧୨୩୪୫୬୭୮୯',
   *   '௦௧௨௩௪௫௬௭௮௯',
   * ].join('\n');
   *
   * console.log(unicodeDigits.translate(list));
   * ```
   */
  constructor(toLanguage, fromLanguages = [...commonLangList]) {
    if (fromLanguages === "all") {
      fromLanguages = Object.keys(supportedLanguageList);
    }
    const removeSelf = fromLanguages.indexOf(toLanguage);
    if (removeSelf !== -1) fromLanguages.splice(removeSelf, 1);
    this._toLangZeroCode = supportedLanguageList[toLanguage];
    const regParts = [];
    for (let n = 0; n < 10; n++) {
      regParts.push("(" + fromLanguages.map((langKey) => String.fromCharCode(supportedLanguageList[langKey] + n)).join("|") + ")");
    }
    this._searchRegExt = new RegExp(regParts.join("|"), "g");
    this._replacer = this._replacer.bind(this);
  }
  /**
   * Convert the String of number of the source language to the destination language.
   *
   * @param {string} str - String of number of the source language.
   * @returns String of number of the destination language.
   *
   * Example:
   *
   * ```ts
   * const list = [
   *   '0123456789',
   *   '٠١٢٣٤٥٦٧٨٩',
   *   '߀߁߂߃߄߅߆߇߈߉',
   *   '०१२३४५६७८९',
   *   '০১২৩৪৫৬৭৮৯',
   *   '੦੧੨੩੪੫੬੭੮੯',
   *   '૦૧૨૩૪૫૬૭૮૯',
   *   '୦୧୨୩୪୫୬୭୮୯',
   *   '௦௧௨௩௪௫௬௭௮௯',
   * ].join('\n');
   *
   * console.log(unicodeDigits.translate(list));
   * ```
   */
  translate(str) {
    return str.trim() === "" ? str : str.replace(this._searchRegExt, this._replacer);
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  UnicodeDigits
});
//# sourceMappingURL=main.cjs.map
